quality <- function(csvfldr, peakinfofile, cutoff) {
   Q.R <- function(fname,cutoff) {
        tmp <- read.files(fname)
        dat <- tmp[tmp[,1]>cutoff,]
        n <- dim(dat)[1]
        nse <- noise(dat[,2], span=5)
        nse.evlp <- 3*sigma(nse, span=251)
        area0 <- intg(dat[,2], dat[,1])
        area1 <- intg(dat[,2]-nse.evlp, dat[,1])
        Quality <- area1/area0
        Retain <- sum(dat[,2]>5*nse.evlp)/n
        return(c(Quality=Quality, Retain=Retain))
   }
        fs <- list.files(path=csvfldr, pattern="*csv*") 
        qrs <- t(sapply(paste(csvfldr,fs,sep="/"), Q.R, 
		cutoff=cutoff))
        fns <- basename(dimnames(qrs)[[1]])
        pks <- read.csv(peakinfofile, as.is=T)
        ns <- sapply(split(pks$"Peak.", pks$"Spectrum.Tag"), 
                length)
        peak <- ns / mean(ns)
        matched <- match(fns, names(peak))
        keep <- !is.na(matched)
        mtc <- matched[keep]
        res <- cbind(qrs[keep,], peak=peak[mtc])
        dimnames(res)[[1]] <- fns[keep]
        return(res)
}

